Leetcode 39. 组合总和

39 阅读1分钟

题目要求

给你一个 无重复元素 的整数数组 candidates 和一个目标整数 target ,找出 candidates 中可以使数字和为目标数 target 的 所有 不同组合 ,并以列表形式返回。你可以按 任意顺序 返回这些组合。

candidates 中的 同一个 数字可以 无限制重复被选取 。如果至少一个数字的被选数量不同,则两种组合是不同的。

对于给定的输入,保证和为 target 的不同组合数少于 150 个。

示例 1:

输入:candidates = [2,3,6,7], target = 7 输出:[[2,2,3],[7]] 解释: 2 和 3 可以形成一组候选,2 + 2 + 3 = 7 。注意 2 可以使用多次。 7 也是一个候选, 7 = 7 。 仅有这两种组合。

示例 2:

输入: candidates = [2,3,5], target = 8 输出: [[2,2,2,2],[2,3,3],[3,5]]

示例 3:

输入: candidates = [2], target = 1 输出: []

解题思路

这道题是比较典型的回溯算法的题目,需要注意的是如何避免重复结果。

因为题目中说到,candidates数组中无重复元素,所以可以直接通过只选择index及其之后的元素,来避免重复。

如果题目中给的candidates数组有重复元素,则需要判断当前index与之前的元素是否有重复,有重复的元素都需要过滤。

Java代码

class Solution {

    List<List<Integer>> res = new ArrayList<>();

    public List<List<Integer>> combinationSum(int[] candidates, int target) {
        dfs(new ArrayList<>(), candidates, 0, target);
        return res;
    }

    private void dfs(List<Integer> cur, int[] candidates, int index, int target){
        if(target == 0){
            res.add(new ArrayList<>(cur));
            return;
        }
        if(target < 0) return;
        for(int i = index; i < candidates.length; i++){
            cur.add(candidates[i]);
            dfs(cur, candidates, i, target - candidates[i]);
            cur.remove(cur.size() - 1);
        }
    }
}

总结

回溯法的题目有标准的模板,写起来不难,重点是要注意判断重复元素,避免输出的结果有重复。